% Blaise Pascal University
% T. Chateau
% track.m
function track_pf
Basename = 'im/';   % basename of image files
ext = 'jpg' ; % extension used
FirstImage = 600 ; % first image of the sequence
LastImage = 800 ; % last  image of the sequence
step = 5 ; % step between 2 images 
first = 1 ; 
Nbp = 200 ; % Nb of particles
Pmem = [];
for i=FirstImage:step:LastImage
  filename = sprintf('%s%0.8d.%s',Basename,i,ext);
  imb=imread(filename);
  imb=imb(:,:,1); % we keep the red component
  im=double(imb);
  figure (1) ; subplot(2,2,1); imshow(imb);
  drawnow;
  title(filename);
  if(first)
   figure (1) ; subplot(2,2,1); imshow(imb);
   drawnow;
   [x,y]=ginput(1)
    % Particle filter initialisation
    part = repmat([y,x],Nbp,1); % particles
    w = ones(Nbp,1)./Nbp; % weigth 
    first=0;
    imprec=im;
  else
  % diff image
  th=10 ;
  imdif=abs(imprec-im);
  alpha=0.2;
  imprec=alpha.*im+(1-alpha).*imprec;
  imt=imdif;
  imt(find(imdif>th))=0;
  imt(find(imdif<=th))=255;
  sigma = 20 ; %  size of object
  N = 300 ; % number of points used 
  %
  % Particle filter
  %
  % random step according to a gaussian law 
  bx = 5 ; %horizontal noise: std of gaussian law
  by = 5 ; %vertical noise: std of gaussian law
  %%%%%%%
  %% Must be completed by student
  % a) Resampling
  % ...
  % b) Prediction
  % ...
  % c) update
  % ...
  % d) state estimation: Pest
  pest = part(1,:); % TO BE CHANGED
  %
  Pmem = [Pmem ; pest]; % Save pest
  l = pest(1);
  c = pest(2);
  %% Display
  figure (1) ; subplot(2,2,1); imshow(imb);
  drawnow;
  subplot(2,2,2)
  imagesc(imdif);
  title('dif image');
  subplot(2,2,3)
  imagesc(imt);
  title('thresholded image');
  subplot(2,2,1)
  hold on
  % plot particles (comment to remove plot)
  plot(part(:,2),part(:,1),'+g');
  % plot estimation
  plot(c,l,'*r');
  % plot trajectory
  plot(Pmem(:,2),Pmem(:,1),'-r');
  hold off
  subplot(2,2,4)
  hist(part(:,1));
  axis([0 300 0 300]);
  title('y pdf');
  end
  drawnow;
end

function [vote] = calc_poids(m,sigma,N);
% m : foreground binary image
% sigma : bandwidth
% number of points drawn (subsampling)
vote = zeros(size(m,1),size(m,2));
[i,j]=find(m(:,:)==0);%foreground
if(~isempty(i))
  if(size(i,1)>N)
    c=randperm(size(i,1));
  else
    c=1:size(i,1);
    N = size(i,1);
  end
  i=i(c(1:N));
  j=j(c(1:N));
  alpha=1;
  for k1=1:length(i)
    for k2=1:length(i)
      cout=exp(-alpha*(((i(k1)-i(k2))^2 + (j(k1)-j(k2))^2))/(2*sigma^2))/(((2*pi)^0.5)*sigma);
      vote(i(k1),j(k1))=vote(i(k1),j(k1))+cout;
    end
  end
end

function [vote] = calc_poids2(p,m,sigma,N);
% p : particles
% m : foreground binary matrix
% sigma : bandwidth
% N : Number of points drawn (subsampling)
vote = zeros(size(p,1),1);
[i,j]=find(m(:,:)==0);%foreground
if(~isempty(i))
  if(size(i,1)>N)
    c=randperm(size(i,1));
  else
    c=1:size(i,1);
    N = size(i,1);
  end
  i=i(c(1:N));
  j=j(c(1:N));
  alpha=1;
  for k1=1:size(p,1)
    for k2=1:length(i)
      cout=exp(-alpha*(((p(k1,1)-i(k2))^2 + (p(k1,2)-j(k2))^2))/(2*sigma^2))/(((2*pi)^0.5)*sigma);
      vote(k1)=vote(k1)+cout;
    end
  end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function newPart=resample(Part,w) % SIR resampling
% Part : particles
% w : weigth vector
w=w./sum(w); % 
wcum=cumsum(w); % 
alea=rand(size(w));
wcum=wcum./wcum(end);
d=0.*w;
newPart=0.*Part;
for i=1:size(w)
  z=find(alea(i)<wcum);
  ind(i)=z(1);
  newPart(i,:)=Part(ind(i),:);
end

